Index: uspace/lib/ui/src/checkbox.c
===================================================================
--- uspace/lib/ui/src/checkbox.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/checkbox.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -192,11 +192,7 @@
 
 		gfx_text_fmt_init(&fmt);
+		fmt.color = checkbox->res->entry_fg_color;
 		fmt.halign = gfx_halign_center;
 		fmt.valign = gfx_valign_center;
-
-		rc = gfx_set_color(checkbox->res->gc,
-		    checkbox->res->entry_fg_color);
-		if (rc != EOK)
-			goto error;
 
 		rc = gfx_puttext(checkbox->res->font, &box_center, &fmt, "X");
@@ -207,13 +203,9 @@
 	/* Paint checkbox label */
 
-	rc = gfx_set_color(checkbox->res->gc, checkbox->res->wnd_text_color);
-	if (rc != EOK)
-		goto error;
-
-	/* Label position */
 	pos.x = box_rect.p1.x + checkbox_label_margin;
 	pos.y = (box_rect.p0.y + box_rect.p1.y) / 2;
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = checkbox->res->wnd_text_color;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_center;
Index: uspace/lib/ui/src/entry.c
===================================================================
--- uspace/lib/ui/src/entry.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/entry.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -208,10 +208,7 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = entry->res->entry_fg_color;
 	fmt.halign = entry->halign;
 	fmt.valign = gfx_valign_top;
-
-	rc = gfx_set_color(entry->res->gc, entry->res->entry_fg_color);
-	if (rc != EOK)
-		goto error;
 
 	rc = gfx_puttext(entry->res->font, &pos, &fmt, entry->text);
Index: uspace/lib/ui/src/label.c
===================================================================
--- uspace/lib/ui/src/label.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/label.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -193,10 +193,7 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = label->res->wnd_text_color;
 	fmt.halign = label->halign;
 	fmt.valign = gfx_valign_top;
-
-	rc = gfx_set_color(label->res->gc, label->res->wnd_text_color);
-	if (rc != EOK)
-		goto error;
 
 	rc = gfx_puttext(label->res->font, &pos, &fmt, label->text);
Index: uspace/lib/ui/src/pbutton.c
===================================================================
--- uspace/lib/ui/src/pbutton.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/pbutton.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -269,8 +269,4 @@
 		goto error;
 
-	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_text_color);
-	if (rc != EOK)
-		goto error;
-
 	/* Center of button rectangle */
 	pos.x = (rect.p0.x + rect.p1.x) / 2;
@@ -283,4 +279,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = pbutton->res->btn_text_color;
 	fmt.halign = gfx_halign_center;
 	fmt.valign = gfx_valign_center;
Index: uspace/lib/ui/src/rbutton.c
===================================================================
--- uspace/lib/ui/src/rbutton.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/rbutton.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -274,14 +274,9 @@
 	/* Paint rbutton label */
 
-	rc = gfx_set_color(rbutton->group->res->gc,
-	    rbutton->group->res->wnd_text_color);
-	if (rc != EOK)
-		goto error;
-
-	/* Label position */
 	pos.x = center.x + rbutton_oframe_r + rbutton_label_margin;
 	pos.y = center.y;
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = rbutton->group->res->wnd_text_color;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_center;
Index: uspace/lib/ui/src/wdecor.c
===================================================================
--- uspace/lib/ui/src/wdecor.c	(revision 2ab8ab3c0a1e9771074c6e9d07ec1bf5e87ddafc)
+++ uspace/lib/ui/src/wdecor.c	(revision b433f680f34a7d7efa45fd40a984f289825e59b4)
@@ -213,4 +213,7 @@
 
 		gfx_text_fmt_init(&fmt);
+		fmt.color = wdecor->active ?
+		    wdecor->res->tbar_act_text_color :
+		    wdecor->res->tbar_inact_text_color;
 		fmt.halign = gfx_halign_center;
 		fmt.valign = gfx_valign_center;
@@ -218,10 +221,4 @@
 		pos.x = (trect.p0.x + trect.p1.x) / 2;
 		pos.y = (trect.p0.y + trect.p1.y) / 2;
-
-		rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
-		    wdecor->res->tbar_act_text_color :
-		    wdecor->res->tbar_inact_text_color);
-		if (rc != EOK)
-			return rc;
 
 		rc = gfx_puttext(wdecor->res->font, &pos, &fmt, wdecor->caption);
